#ifndef _PXI7007_DEVICE_
#define _PXI7007_DEVICE_


#define PXI7007_REG_MAX_CHANNELS		5	// ֧5ͨ

//***********************************************************
// ûӿ
#ifndef _PXI7007_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## ͨú #################################
	// ڱ豸
	HANDLE DEVAPI FAR PASCAL PXI7007_CreateDevice(LONG lDeviceID = 0);		// 豸
	HANDLE DEVAPI FAR PASCAL PXI7007_CreateDeviceEx(LONG lPhysIdx = 0);		// ID豸
	int DEVAPI FAR PASCAL PXI7007_GetDeviceCount(HANDLE hDevice);			// ȡ豸̨
	BOOL DEVAPI FAR PASCAL PXI7007_ListDeviceDlg(HANDLE hDevice);			// бϵͳееĸPCI豸
    BOOL DEVAPI FAR PASCAL PXI7007_ReleaseDevice(HANDLE hDevice);			// ر豸,ֹ,ͷԴ


	// ################################ 豸Ϣ ################################
	BOOL DEVAPI FAR PASCAL PXI7007_GetPhysIdx(					// , ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									PULONG pPhysIdx);			// ص

	BOOL DEVAPI FAR PASCAL PXI7007_SetPhysIdx(					// , ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									ULONG nPhysIdx);			// 

	BOOL DEVAPI FAR PASCAL PXI7007_GetDevVersion(					// ȡ豸̼汾
									HANDLE hDevice,			// 豸,CreateDevice
									PULONG pulFmwVersion,	// ̼汾
									PULONG pulDriverVersion);// 汾

	BOOL DEVAPI FAR PASCAL PXI7007_GetSerialNum(				// к, ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									PULONG pSerialNum);		// صк

	BOOL DEVAPI FAR PASCAL PXI7007_GetUserPID(					// ûƷID(User Product Identification), ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									PULONG pUserPID);			// صûƷID

	BOOL DEVAPI FAR PASCAL PXI7007_SetUserPID(					// ûƷID(User Product Identification), ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									ULONG nUserPID);			// ûƷID


	// ################################ 뺯 ################################
	BOOL DEVAPI FAR PASCAL PXI7007_SetPassword(ULONG nPassword);// ޸к

	// ################################ 豸Ϣ ################################
	BOOL DEVAPI FAR PASCAL PXI7007_SetSerialNum(				// к, ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									ULONG nSerialNum);		// к

	//############################ ɱ̵ƺ #######################################
	BOOL DEVAPI FAR PASCAL PXI7007_SetResistance(			// ֵͨ
									HANDLE hDevice,			// 豸,CreateDevice
									ULONG lResistance,		// ֵͨ(1ŷ65535ŷ)
									ULONG lChannel);		// ͨѡ(04)

	BOOL DEVAPI FAR PASCAL PXI7007_GetResistance(			// ȡֵͨ
									HANDLE hDevice,			// 豸,CreateDevice
									PULONG lResistance,		// ֵͨ(1ŷ65535ŷ)
									ULONG lChannel);		// ͨѡ(04)

	//################# ڴӳĴֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	BOOL DEVAPI FAR PASCAL PXI7007_GetDeviceBar(			// ȡָָ豸ĴBARַ
									HANDLE hDevice,			// 豸,CreateDevice
									__int64 pbPCIBar[6]);	// PCI BARеַ,PCI BARжٿõַ뿴Ӳ˵


	BOOL DEVAPI FAR PASCAL PXI7007_WriteRegisterByte(		// ָĴռλд뵥
									HANDLE hDevice,			// 豸,CreateDevice
									__int64 pbLinearAddr,		// ָĴԻַ,GetDeviceAddrеpbLinearAddrֵ
									ULONG OffsetBytes,		// Իַַƫλ(ֽ)
									BYTE Value);			// ַָд뵥ֽݣַԻַƫλþ

	BOOL DEVAPI FAR PASCAL PXI7007_WriteRegisterWord(		// д˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									WORD Value);

	BOOL DEVAPI FAR PASCAL PXI7007_WriteRegisterULong(		// дĽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									ULONG Value);

	BYTE DEVAPI FAR PASCAL PXI7007_ReadRegisterByte(		// 뵥ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	WORD DEVAPI FAR PASCAL PXI7007_ReadRegisterWord(		// ˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	ULONG DEVAPI FAR PASCAL PXI7007_ReadRegisterULong(		// ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	//################# I/O˿ֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	// ЩҪڴͳ豸ISAߡڡڵ豸ڱPCI豸
	BOOL DEVAPI FAR PASCAL PXI7007_WritePortByte(			// 8λд˿
									HANDLE hDevice,			// 豸(CreateDevice)
									__int64 pPort,				// ˿ڵַ
									BYTE Value);			// д8λ

	BOOL DEVAPI FAR PASCAL PXI7007_WritePortWord(HANDLE hDevice, __int64 pPort, WORD Value);
	BOOL DEVAPI FAR PASCAL PXI7007_WritePortULong(HANDLE hDevice, __int64 pPort, ULONG Value);

	BYTE DEVAPI FAR PASCAL PXI7007_ReadPortByte(HANDLE hDevice, __int64 pPort);
	WORD DEVAPI FAR PASCAL PXI7007_ReadPortWord(HANDLE hDevice, __int64 pPort);
	ULONG DEVAPI FAR PASCAL PXI7007_ReadPortULong(HANDLE hDevice, __int64 pPort);

	//########################### ̲߳ ######################################
	HANDLE DEVAPI FAR PASCAL PXI7007_CreateSystemEvent(void);			// ں¼󣬹InitDeviceIntVB̵߳Ⱥʹ
	BOOL DEVAPI FAR PASCAL PXI7007_ReleaseSystemEvent(HANDLE hEvent);	// ͷں¼


#ifdef __cplusplus
}
#endif

// Զ
#ifndef _PXI7007_DRIVER_
	#ifndef _WIN64
		#pragma comment(lib, "PXI7007_32.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PXI7007_32.dll...")
		#pragma message("======== Successfully linked with PXI7007_32.dll")
	#else
		#pragma comment(lib, "PXI7007_64.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PXI7007_64.dll...")
		#pragma message("======== Successfully linked with PXI7007_64.dll")
	#endif

#endif

#endif // _PXI7007_DEVICE_
